
'Angedacht fr Ladegerte die eine eigenstndige Ladekontrolle haben, oder
'fr wiederkehrende Erhaltungsladung mit Dauerstrom auf Zeit
'
'Ein Quarz-Takt ist nicht erforderlich da mit der Netzfrequenz = 50 Hz
'synchronisiert wird. Ab Start des Timers wird die einprogrammierte Zeit mit der
'Netzfrequenz konstant gehalten, diese wird bekanntlich von den EVU's ber lngere
'Zeit wieder exakt auf 50 Hz Synchronitt gebracht.

'Achtung: Fuse Bits: BODLEVEL 2,7V



                               'Angaben fr den Kompiler
                               '------------------------

'Prozessor
$regfile = "attiny13.dat"

'intern Takt 1,2 MHz
$crystal = 1200000

'STACK reservierung
$hwstack = 10
$swstack = 15
$framesize = 10

'Variable
Dim Z As Dword
Dim C As Byte

'conf Port's B auf Eingabe=0, Ausgabe=1
Ddrb = &B0001_1000

'Strom sparen
Stop Adc                                                    'Switch off ADC
Stop Ac                                                     'Switch off the power to the Analog Comparator
Reset Acsr. Acbg                                            'Disable Analog Comparator Bandgap Select

'LED grn blinkt 10x schnell (ist der Tiny13 einwandfrei gestartet, RESET)
    For C = 1 To 10
         Portb.4 = 1
         Waitms 200
         Portb.4 = 0
         Waitms 200
    Next C

    C = 0

'Ein bis zwei Halbwellen zum Synchronisieren (erfllt zerro cross Bedingung fr SSR)
Do
Loop Until Pinb.2 = 0                                       'weiter bei neg. Halbwelle
Do
Loop Until Pinb.2 = 1                                       'weiter bei pos. Halbwelle


                                 'Programmschleife


'Netz eingeschaltet   ====================================================================

Netz_ein:

   Z = 0                                                    'Zhler auf 0

   Portb.4 = 0                                              'Grne LED aus
   Portb.3 = 1                                              'SSR und rote Led ein

Schleife_ein:

   Z = Z + 1                                                'Zhler um 20ms erhhen

   Do
   Loop Until Pinb.2 = 0                                    'weiter bei neg. Halbwelle

   Waitms 13                                                'warten auf pos. Halbwelle                                         'warten auf pos. Halbwelle

   If Z = 1440000 Then Goto Netz_aus                        '1440000 = 8H ein

Goto Schleife_ein


'Netz ausgeschaltet   ====================================================================

Netz_aus:

   Z = 0                                                    'Zhler auf 0
   C = 0

   Portb.3 = 0                                              'SSR und rote Led aus

Schleife_aus:

   Z = Z + 1                                                'Zhler um 20ms erhhen

   Do
   Loop Until Pinb.2 = 0                                    'weiter bei neg. Halbwelle

'Kontrolle bei langer Laufzeit "hang on?" (luft noch alles?) grne LED blinkt
   C = C + 1
   If C = 20 Then Portb.4 = 0
   If C = 40 Then Portb.4 = 1
   If C = 40 Then C = 0

   Waitms 13                                                'warten auf pos. Halbwelle

   If Z = 192960000 Then Goto Netz_ein                      '192960000 = 44T/16H aus

Goto Schleife_aus